SystemOrganization addCategory: #'acceptit-Core-Compiler'!
SystemOrganization addCategory: #'acceptit-Core-Model'!

OMeta2 subclass: #ACParser
	instanceVariableNames: 'stParser'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'acceptit-Core-Compiler'!

!ACParser methodsFor: 'helpers' stamp: 'topa 5/18/2010 18:05'!
charNoNewline =

	<char:x ?[x ~= Character cr]>! !

!ACParser methodsFor: 'public access' stamp: 'topa 9/23/2010 12:39'!
encoderClass: aClass

	stParser encoderClass: aClass.! !

!ACParser methodsFor: 'parsing' stamp: 'topa 9/22/2010 10:22'!
endOfLastToken
	" this should only happen after #parseSelector: "
	
	^ stParser endOfLastToken! !

!ACParser methodsFor: 'initialize-release' stamp: 'topa 3/11/2011 17:10'!
initialize

	super initialize.
	stParser := self class parserClass new.
! !

!ACParser methodsFor: 'helpers' stamp: 'topa 5/18/2010 17:51'!
lineEnd =

	<char:x ?[x = Character cr]>! !

!ACParser methodsFor: 'as yet unclassified' stamp: 'topa 9/22/2010 14:25'!
parse: sourceStreamOrString class: behavior 
	^ self parse: sourceStreamOrString readStream class: behavior
		noPattern: false context: nil notifying: nil ifFail: [^nil]! !

!ACParser methodsFor: 'public access' stamp: 'topa 9/23/2010 12:40'!
parse: sourceStream class: cls noPattern: pat context: ctx notifying: req ifFail: block 
	
	
	| codeToParse |
	[ | parseTree | 
		parseTree := self class matchStream: (sourceStream contents asString readStream) with: self startRule withArgs: #() withPlaybackDebugging: false.
		codeToParse := ACTranslator match: parseTree with: self startRule.
		codeToParse := codeToParse readStream.
	] on: OM2Fail do: [:ignore | 
		codeToParse := sourceStream reset. "fallback. especially for St-classes"].

	^ stParser 
		parse: codeToParse
		class: cls
		noPattern: pat
		context: ctx
		notifying: req
		ifFail: block! !

!ACParser methodsFor: 'parsing' stamp: 'topa 9/23/2010 12:44'!
parseSelector: aStringOrText

	| codeToParse |
	[ | parseTree | 
		parseTree := self class matchStream: aStringOrText asString readStream with: self startRule withArgs: #() withPlaybackDebugging: false.
		codeToParse := ACTranslator match: parseTree with: self startRule.
	] on: OM2Fail do: [:ignore | 
		codeToParse := aStringOrText "fallback. especially for St-classes"].
	^ stParser parseSelector: codeToParse
! !

!ACParser methodsFor: 'shout' stamp: 'topa 12/6/2010 18:52'!
rangesIn: sourceString classOrMetaClass: aBehaviour workspace: aWorkspace  environment: anEnvironmentOrNil

	^ nil
	! !

!ACParser methodsFor: 'helpers' stamp: 'topa 5/20/2010 09:59'!
space =
	// we do not allow newline as whitespace
	
	^space:s ?[ ({Character cr. Character lf} noneSatisfy: [:c | c =s ])]! !

!ACParser methodsFor: 'ometa' stamp: 'topa 9/22/2010 11:22'!
startRule
	" specify the OMeta-rule parsing shall start with "

	self subclassResponsibility! !

ACParser subclass: #ACSDParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'acceptit-Core-Compiler'!

!ACSDParser methodsFor: 'stepDefinition-Rules' stamp: 'topa 9/22/2010 11:19'!
methodBody :sel = 

	<char+>:body -> [{body}]! !

!ACSDParser methodsFor: 'stepDefinition-Rules' stamp: 'topa 9/22/2010 11:19'!
selectorLine =

	selectorTag:t spaces <charNoNewline+>:sel -> [{t. sel}]! !

!ACSDParser methodsFor: 'stepDefinition-Rules' stamp: 'topa 9/22/2010 11:19'!
selectorTag =

	spaces <``(''>  <(``given'' | ``when'' | ``then'')>:tag <``)''> spaces  -> [tag asSymbol]! !

!ACSDParser methodsFor: 'ometa' stamp: 'topa 9/22/2010 11:25'!
startRule

	^ #stepDefinition! !

!ACSDParser methodsFor: 'stepDefinition-Rules' stamp: 'topa 9/22/2010 11:55'!
stepDefinition =

		selectorLine:s lineEnd
		(methodBody(s):b lineEnd?)? end 
			-> [s, b]
		! !

ACParser subclass: #ACUSParser
	instanceVariableNames: 'tempString'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'acceptit-Core-Compiler'!

ACUSParser subclass: #ACUSAnnotatedParser
	instanceVariableNames: 'sourceLine'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'acceptit-Core-Compiler'!

!ACUSAnnotatedParser methodsFor: 'as yet unclassified' stamp: 'topa 3/11/2011 17:20'!
and =

	sourceLine:s
	 ^and:body -> [s -> body]! !

!ACUSAnnotatedParser methodsFor: 'as yet unclassified' stamp: 'topa 3/11/2011 17:19'!
annotatedLines :rule =

	sourceLine:s
	apply(rule):firstBody
	(lineEnd and)*:andBodies -> [{rule . s -> firstBody} , andBodies]
! !

!ACUSAnnotatedParser methodsFor: 'as yet unclassified' stamp: 'topa 3/11/2011 17:08'!
incrementSourceLine

	sourceLine := sourceLine + 1.! !

!ACUSAnnotatedParser methodsFor: 'as yet unclassified' stamp: 'topa 3/11/2011 17:09'!
initialize 

	super initialize.
	sourceLine := 1.! !

!ACUSAnnotatedParser methodsFor: 'as yet unclassified' stamp: 'topa 3/11/2011 17:20'!
lineEnd =

	<char:x ?[x = Character cr] 	[self incrementSourceLine]	>! !

!ACUSAnnotatedParser methodsFor: 'as yet unclassified' stamp: 'topa 3/11/2011 17:22'!
scenario =

	title:t lineEnd+
	annotatedLines(#given):given lineEnd
	annotatedLines(#when):when lineEnd
	annotatedLines(#then):then lineEnd? end -> [{#annotated . {#scenario . t . given. when. then}}]
	! !

!ACUSAnnotatedParser methodsFor: 'as yet unclassified' stamp: 'topa 3/11/2011 17:07'!
sourceLine 

	^ sourceLine! !

!ACUSParser class methodsFor: 'as yet unclassified' stamp: 'topa 3/11/2011 17:11'!
scenarioParseTree: aStream

	^ self 
		matchStream: aStream 
		with: #scenario
		withArgs: #() 
		withPlaybackDebugging: false.! !

!ACUSParser methodsFor: 'scenario-rules' stamp: 'topa 3/11/2011 16:11'!
and =

	 spaces <``And''> spaces <charNoNewline+>:body -> [body]! !

!ACUSParser methodsFor: 'scenario-rules' stamp: 'topa 3/11/2011 14:45'!
anyRule =

	given:g 			-> [{#given. g}]
|	when:w			-> [{#when. w}]
|	then:t 			-> [{#then. t}]
! !

!ACUSParser methodsFor: 'scenario-rules' stamp: 'topa 9/22/2010 11:20'!
applyLines :rule =

	apply(rule):firstBody
	(lineEnd and)*:andBodies -> [{rule . firstBody} , andBodies]
! !

!ACUSParser methodsFor: 'parser emulation' stamp: 'topa 9/22/2010 14:11'!
endOfLastToken

	^ (tempString indexOf: Character cr startingAt: 1)
		min: (tempString indexOf: Character lf startingAt: 1)! !

!ACUSParser methodsFor: 'scenario-rules' stamp: 'topa 9/22/2010 11:20'!
given =

	 spaces <``Given''> spaces <charNoNewline+>:body -> [body]! !

!ACUSParser methodsFor: 'userStory-rules' stamp: 'topa 9/22/2010 11:20'!
meansLine =

	spaces <``I want'' `` to''?> spaces <charNoNewline+>:body -> [{#means . body}]! !

!ACUSParser methodsFor: 'parser emulation' stamp: 'topa 12/6/2010 18:55'!
parseSelector: aStringOrText

	tempString := aStringOrText.
	^ aStringOrText asString lines first! !

!ACUSParser methodsFor: 'userStory-rules' stamp: 'topa 9/22/2010 11:20'!
purposeLine =

	 spaces <``In order to''> spaces <charNoNewline+>:body -> [{#purpose . body}]! !

!ACUSParser methodsFor: 'as yet unclassified' stamp: 'topa 12/6/2010 19:20'!
rangesIn: sourceString classOrMetaClass: aBehaviour workspace: aWorkspace  environment: anEnvironmentOrNil

	| line |
	sourceString lines ifEmpty: [^{}].
	line := sourceString lines first.
	^ { SHRange start: 1 end: line size type: #patternKeyword }
! !

!ACUSParser methodsFor: 'userStory-rules' stamp: 'topa 9/22/2010 11:20'!
roleLine =

		 spaces <``As a'' ``n''?> spaces <charNoNewline+>:body -> [{#role . body}]! !

!ACUSParser methodsFor: 'scenario-rules' stamp: 'topa 9/22/2010 11:20'!
scenario =

	title:t lineEnd+
	applyLines(#given):given lineEnd
	applyLines(#when):when lineEnd
	applyLines(#then):then lineEnd? end -> [{#scenario. t. given. when. then}]
	! !

!ACUSParser methodsFor: 'ometa' stamp: 'topa 9/22/2010 11:25'!
startRule

	^ #scenario! !

!ACUSParser methodsFor: 'scenario-rules' stamp: 'topa 9/22/2010 11:20'!
then =

	 spaces <``Then''> spaces <charNoNewline+>:body -> [body]! !

!ACUSParser methodsFor: 'userStory-rules' stamp: 'topa 9/22/2010 11:20'!
title =

	<charNoNewline+>:body -> [{#title . body}]! !

!ACUSParser methodsFor: 'userStory-rules' stamp: 'topa 9/22/2010 11:20'!
userStory =
	
	title:t lineEnd+
	purposeLine:purpose lineEnd
	roleLine:role lineEnd
	meansLine:means lineEnd? end -> [{#userStory. t. purpose. role. means}]
	! !

!ACUSParser methodsFor: 'scenario-rules' stamp: 'topa 9/22/2010 11:20'!
when =

	 spaces <``When''> spaces <charNoNewline+>:body -> [body]! !

OMeta2 subclass: #ACTranslator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'acceptit-Core-Compiler'!

!ACTranslator class methodsFor: 'as yet unclassified' stamp: 'topa 8/31/2010 03:00'!
bindParametersInCollection: aCollection toValuesIn: aString

	|result runString|
	
	result := OrderedCollection new.
	runString := aString.
	1 to: aCollection size - 1 by: 2 do: [:i | 
		[:prev :parameter :next | |var secondLength |
			next isEmpty 
				ifTrue: [secondLength := runString size]
				ifFalse: [secondLength := (runString findString: next) - 1].
			var := runString copyFrom: prev size + 1 to: secondLength.
			runString := runString allButFirst: prev size + var size.
			result add: parameter  -> var]
		value: (aCollection at: i)
		value: (aCollection at: i + 1)
		value: (aCollection at: i + 2)]	.

	^ result! !

!ACTranslator class methodsFor: 'as yet unclassified' stamp: 'topa 8/31/2010 03:06'!
bindParametersInSelector:aSelector toValuesIn: aString

	^ ACTranslator bindParametersInCollection: (self buildSelectorPartsFromString: aSelector) toValuesIn: aString
! !

!ACTranslator class methodsFor: 'as yet unclassified' stamp: 'topa 8/31/2010 03:08'!
buildSelectorPartsFromString: aString

	^ Array streamContents: [:stream |	
		"extract the parameters (start with : )"
		(aString findTokens: $:) withIndexDo: [:e :i |
			i ~= 1 
				ifTrue: [ |parameter|
					parameter := e upTo: $ .
					stream 
						nextPut: ':', parameter; "parameter"
						nextPut: (e allButFirst: parameter size)] "rest"
				ifFalse: [stream nextPut: e "start of selector"]]].! !

!ACTranslator class methodsFor: 'as yet unclassified' stamp: 'topa 8/31/2010 03:20'!
parameterStringFor: aString

	^ String streamContents: [:stream |
		(aString findTokens: $:) allButFirst do: [:sub |
			stream nextPut: $:;
				nextPutAll: (sub upTo: $ );
				space].
		(aString includes: $:) ifTrue: [stream nextPut: $|]]
! !

!ACTranslator class methodsFor: 'as yet unclassified' stamp: 'topa 8/31/2010 03:16'!
replaceParametersWithStarsIn: aString

	^ String streamContents: [:stream | | parts |
		(parts := self buildSelectorPartsFromString: aString)
			withIndexDo: [:part :index | 
				index odd 
					ifTrue: [stream nextPutAll: part]
					ifFalse: [
						(index < parts size) ifTrue: [stream nextPut: $*]]]].! !

!ACTranslator methodsFor: 'as yet unclassified' stamp: 'topa 6/3/2010 13:27'!
messagePart =

	{symbol:s string:body} -> ['	', s asMutator,' ''', body,'''', String cr]! !

!ACTranslator methodsFor: 'as yet unclassified' stamp: 'topa 6/30/2010 14:27'!
rule =

	{symbol:s string+:bodies} -> [ String streamContents: [:stream | 
			bodies do: [:body | stream nextPutAll: '	self ';  nextPutAll: s asMutator; space; nextPutAll: body printString; nextPut: $.; cr]]]! !

!ACTranslator methodsFor: 'as yet unclassified' stamp: 'topa 9/22/2010 11:23'!
scenario =
	
	{symbol:type ?[type = #userStory] title:t messagePart:purpose messagePart:role messagePart:means}
		-> [t, purpose, role, means]
|	{symbol:type ?[type = #scenario] {symbol:ign string:t} rule:given rule:when rule:then}
		-> [t asLegalSelector, self scenarioAnnotation, given, when, then]! !

!ACTranslator methodsFor: 'as yet unclassified' stamp: 'fg 6/15/2010 15:20:38.788'!
scenarioAnnotation

	^ String streamContents: [:stream |
		stream crtab; 	nextPutAll: '<scenario>'; cr]! !

!ACTranslator methodsFor: 'as yet unclassified' stamp: 'topa 9/22/2010 11:58'!
selectorAndStart =

	symbol:tag string:sel -> [(tag, sel asCamelCase, 'Args')  asLegalSelector asString, ': privateArgsCollection',
		String cr, String tab, '<stepTag: ', tag printString, '>',
		String cr, String tab, '<stepMatch: ', (self class replaceParametersWithStarsIn: sel) printString, '>',
		String cr, String tab, '<step: ', sel printString, '>', String cr, '[', (self class parameterStringFor: sel), String cr]! !

!ACTranslator methodsFor: 'as yet unclassified' stamp: 'topa 9/23/2010 12:59'!
stepDefinition =

	{selectorAndStart:start string:body} -> [start,  body, String cr, '] valueWithPossibleArgs: (privateArgsCollection asArray).', String cr]! !

!ACTranslator methodsFor: 'as yet unclassified' stamp: 'topa 6/3/2010 13:35'!
title =

	{symbol:t string:s} -> ['ACUserStory named: ', s asLegalSelector capitalized asSymbol printString, String cr]! !

TestSuite subclass: #ACTestSuite
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'acceptit-Core-Model'!

!ACTestSuite methodsFor: 'as yet unclassified' stamp: 'db 10/5/2010 05:13'!
run
	| result |
 	result := ACScenarioResult new.
	self resources do: [ :res |
		res isAvailable ifFalse: [^res signalInitializationError]].
	[self run: result] ensure: [self resources do: [:each | each reset]].
	^result
			! !

TestResult subclass: #ACScenarioResult
	instanceVariableNames: 'stepStatus'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'acceptit-Core-Model'!

!ACScenarioResult methodsFor: 'as yet unclassified' stamp: 'topa 3/11/2011 12:34'!
runCase: aTestCase
	| testCasePassed |
	testCasePassed := true.
	
	[[aTestCase runCase] 
		on: self class failure
		do: [:failure | 
			self setTestCaseFailedFor: aTestCase.
			testCasePassed := false.
			failure return: false]]
				on: self class error
				do:	[:error |
						self setTestCaseErrorFor: aTestCase.
						testCasePassed := false.
						error return: false].
	testCasePassed ifTrue: [self setTestCasePassedFor: aTestCase]! !

!ACScenarioResult methodsFor: 'as yet unclassified' stamp: 'topa 3/11/2011 17:52'!
setStepStatus: lastStatus for: aTestCase

	| currentStep statuus |
	currentStep :=  aTestCase currentStep. 
	"step where error/failure occured: (string->verb) -> method"
	
	statuus := self stepStatus at: aTestCase 
		ifAbsentPut: [Dictionary new].
	
	"process previous steps"
	aTestCase stepsDone do: [:assoc |
		statuus at: assoc key put: #passed].
	
	
	statuus at: (currentStep 
			ifNil: [#all]
			ifNotNil: [:cs | cs key])
		put: lastStatus.
! !

!ACScenarioResult methodsFor: 'as yet unclassified' stamp: 'topa 3/11/2011 15:30'!
setTestCaseErrorFor: aTestCase

	self setStepStatus: #error for: aTestCase.
	errors add: aTestCase. 

	! !

!ACScenarioResult methodsFor: 'as yet unclassified' stamp: 'topa 3/11/2011 12:31'!
setTestCaseFailedFor: aTestCase

	self setStepStatus: #failed for: aTestCase.
	failures add: aTestCase. ! !

!ACScenarioResult methodsFor: 'as yet unclassified' stamp: 'topa 3/11/2011 12:34'!
setTestCasePassedFor: aTestCase

	self setStepStatus: #passed for: aTestCase.
	passed add: aTestCase.! !

!ACScenarioResult methodsFor: 'as yet unclassified' stamp: 'topa 3/11/2011 14:25'!
stepStatus

	stepStatus ifNil: [self stepStatus: Dictionary new].
	^stepStatus! !

!ACScenarioResult methodsFor: 'as yet unclassified' stamp: 'db 10/24/2010 22:33'!
stepStatus: aDict

	stepStatus := aDict! !

Compiler subclass: #ACCompiler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'acceptit-Core-Compiler'!

!ACCompiler methodsFor: 'public access' stamp: 'topa 9/24/2010 14:51'!
compile: origCode in: cls classified: aCategory notifying: notify ifFail: failBlock

	| origCodeStream translatedCode node |
	origCodeStream := origCode asString readStream.
	self from: origCodeStream class: cls context: nil notifying: notify.
	[ | parseTree |
			
		parseTree := self parserClass matchStream: origCodeStream with: #scenario withArgs: #() withPlaybackDebugging: false.
		translatedCode := ACTranslator match: parseTree with: #scenario.
	] on: OM2Fail do: [:ignore |
		self notify: '<-- parse error around here -->' at: origCodeStream position.
		^ failBlock value
	].
	node := self class superclass new
		compile: translatedCode readStream
		in: cls
		classified: aCategory
		notifying: notify
		ifFail: failBlock.
	^ node selector: (origCode asString lines first asSymbol); yourself! !

!ACCompiler methodsFor: 'public access' stamp: 'topa 9/24/2010 14:52'!
compile: origCode in: cls notifying: notify ifFail: failBlock

	^ self compile: origCode in: cls classified: 'scenarios' notifying: notify ifFail: failBlock! !

!ACCompiler methodsFor: 'public access' stamp: 'topa 3/11/2011 15:43'!
parse: aStream class: aClass noPattern: noPattern context: ctxt notifying: req ifFail: aBlock

	^ [
		| parseTree translatedCode code |
		parseTree := self parserClass scenarioParseTree: aStream.
		translatedCode := ACTranslator match: parseTree with: #scenario.
		Parser new parse: translatedCode readStream class: aClass noPattern: noPattern context: ctxt notifying: req ifFail: aBlock
	] on: OM2Fail do: [aBlock value]! !

!ACCompiler methodsFor: 'public access' stamp: 'topa 9/22/2010 11:28'!
parserClass

	^ ACUSParser! !

Compiler subclass: #ACLibraryCompiler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'acceptit-Core-Compiler'!

!ACLibraryCompiler class methodsFor: 'as yet unclassified' stamp: 'topa 9/22/2010 10:30'!
new
	
	" avoid pre-poulation of parser 
	^ self basicNew initialize"
	^ super new! !

!ACLibraryCompiler class methodsFor: 'as yet unclassified' stamp: 'topa 9/22/2010 12:08'!
parserClass

	
	"^ ACSDParser"
	^ super parserClass! !

!ACLibraryCompiler class methodsFor: 'as yet unclassified' stamp: 'topa 3/11/2011 18:57'!
provisionLibrary: aString
	"like ACLibrary generateFromClass: but thinner."
	| newLibrary |
	newLibrary  := Object subclass: aString asSymbol instanceVariableNames: '' classVariableNames: '' poolDictionaries: '' category: 'Generated'.
	
	{ 
'shoutParserClass

	^ ACSHParserForLibrary
'.
'parserClass

^ ACSDParser
'.
	'compilerClass

	^ACLibraryCompiler
'
	} do: [:methodSource | 
		newLibrary theMetaClass 
			compile: methodSource
			notifying: nil.
	].	
	^ newLibrary! !

!ACLibraryCompiler methodsFor: 'public access' stamp: 'topa 9/24/2010 18:02'!
compile: origCode in: cls classified: aCategory notifying: notify ifFail: failBlock

	| origCodeStream translatedCode |
	origCodeStream := origCode asString readStream.
	self from: origCodeStream class: cls context: nil notifying: notify.
	[ | parseTree |
		parseTree := self parserClass matchStream: origCodeStream with: #stepDefinition withArgs: #() withPlaybackDebugging: false.
		translatedCode := ACTranslator match: parseTree with: #stepDefinition.
	] on: OM2Fail do: [:ignore |
		"treat as normal Smalltalk"
	^ Compiler new
		compile: origCodeStream reset
		in: cls
		classified: aCategory
		notifying: notify
		ifFail: failBlock
	].
	^ Compiler new
		compile: translatedCode readStream
		in: cls
		classified: aCategory
		notifying: notify
		ifFail: failBlock! !

!ACLibraryCompiler methodsFor: 'public access' stamp: 'topa 8/5/2010 15:55'!
compile: origCode in: cls notifying: notify ifFail: failBlock

	^ self compile: origCode in: cls 	classified: 'as yet unclassified' notifying: notify 	ifFail: failBlock! !

!ACLibraryCompiler methodsFor: 'as yet unclassified' stamp: 'topa 9/22/2010 10:45'!
parse: aStream class: aClass noPattern: noPattern context: ctxt notifying: req ifFail: aBlock

	^ [
		| parseTree translatedCode code |
		parseTree := self parserClass matchStream: aStream with: #stepDefinition withArgs: #() withPlaybackDebugging: false.
		translatedCode := ACTranslator match: parseTree with: #stepDefinition.
		super parserClass new parse: translatedCode readStream class: aClass noPattern: noPattern context: ctxt notifying: req ifFail: aBlock
	] on: OM2Fail do: [:failure |
		^ super parserClass new parse: aStream class: aClass noPattern: noPattern context: ctxt notifying: req ifFail: aBlock]! !

!ACLibraryCompiler methodsFor: 'public access' stamp: 'topa 9/24/2010 18:03'!
parse: textOrStream in: aClass notifying: req

	| stream |
	stream := textOrStream isStream ifTrue: [textOrStream] ifFalse: [textOrStream asString readStream].
	^ [| parseTree translatedCode code |
		parseTree := self parserClass matchStream: stream with: #stepDefinition withArgs: #() withPlaybackDebugging: false.
		translatedCode := ACTranslator match: parseTree with: #stepDefinition.
		super parse: translatedCode readStream in: aClass notifying: req.
	] on: OM2Fail do: [:failure |
		^ super parse: stream reset in: aClass notifying: req]! !

!ACLibraryCompiler methodsFor: 'as yet unclassified' stamp: 'topa 9/22/2010 12:01'!
parserClass

	^ ACSDParser! !

!String methodsFor: '*acceptit-Core' stamp: 'topa 6/16/2010 14:56'!
asCamelCase
	"Convert to CamelCase. Can be conveinient 
	in conjunction with #asLegalSelector 
	'A man, a plan, a canal, panama' asCamelCase.
	'A man, a plan, a canal, panama' asCamelCase asLegalSelector.
	'Here 123should % be 6 the name6 of the method' asCamelCase.
	'Here 123should % be 6 the name6 of the method' asCamelCase asLegalSelector."
	
	^ self class streamContents: [:stream | 
		self substrings do: [:sub |
			stream nextPutAll: sub capitalized]]! !

!String methodsFor: '*acceptit-Core' stamp: 'topa 7/8/2010 15:06'!
withLeadingAuxiliaryNormalized

	({
		{'am'.'are'.'is'} -> 'is'.
		{'have'.'has'} -> 'has'.
		{'shall'. 'should'} -> 'should'.
		{'may'. 'might'} -> 'may'.
		{'will'. 'would'} -> 'will'.
		{'can'.'could'} -> 'can'.
	} as: Dictionary) keysAndValuesDo: [:key :value|
		(self beginsWithAnyOf: key) 
			ifTrue:[^ value, String space, (self copyAfter: Character space)]].
		
	 ^ self! !

!String methodsFor: '*acceptit-Core' stamp: 'topa 7/8/2010 13:54'!
withoutLeadingSubject

	| s |
	s := self withBlanksCondensed.
	^ (s asLowercase beginsWithAnyOf: #( i he she it you we they ))
		ifTrue: [	s copyAfter: Character space]
		ifFalse: [s]! !

ClassOrganizer subclass: #ACUserStoryOrganizer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'acceptit-Core-Compiler'!

Object subclass: #ACLibrary
	instanceVariableNames: 'scenario'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'acceptit-Core-Model'!

!ACLibrary class methodsFor: 'compiling' stamp: 'topa 3/11/2011 18:50'!
compilerClass

	^ACLibraryCompiler
! !

!ACLibrary class methodsFor: 'provisioning' stamp: 'topa 3/11/2011 22:44'!
generateNewLibrary: aClassOrSymbol
	"inspiration from Browser>>#copyClass"
	
	| newClass newClassName newCategory newInstVars oldClass |
	oldClass  := aClassOrSymbol isSymbol
		ifFalse: [aClassOrSymbol isBehavior ifTrue: [aClassOrSymbol] ifFalse: [Object]]
		ifTrue: [Smalltalk globals at: aClassOrSymbol ifAbsent: [Object]].
	
	newClassName := (aClassOrSymbol asString, 'Library') asSymbol.
	newCategory := (oldClass == Object)
		ifTrue: ['Generated'] 
		ifFalse: [oldClass category].

	newInstVars := (oldClass allInstVarNames includes: 'scenario')
		ifTrue: [self inform: oldClass name, ' already has ''scenario'' instance variable. 
			Please take care of that.'. ''] 
		ifFalse: ['scenario'].
	oldClass 
		subclass: newClassName  
		instanceVariableNames: newInstVars 
		classVariableNames: '' 
		poolDictionaries: '' 
		category: newCategory.
	newClass := Smalltalk globals at: newClassName.
	newClass class
		instanceVariableNames: ''.
	
	"get things going"
	newClass theNonMetaClass copyAllCategoriesFrom: self theNonMetaClass.
	newClass theMetaClass copyAllCategoriesFrom: self theMetaClass.
	newClass theMetaClass removeSelector: #generateNewLibrary:. "pay attention here!!"
	newClass comment: newClass name, ' is an acceptit library.'.
	
	^ newClass
! !

!ACLibrary class methodsFor: 'initialize-release' stamp: 'topa 3/11/2011 18:51'!
newForScenario: aUserStoryObjectBeeingAScenario

	^ self basicNew
		scenario: aUserStoryObjectBeeingAScenario;
		initialize! !

!ACLibrary class methodsFor: 'compiling' stamp: 'topa 3/11/2011 18:50'!
parserClass

	^ ACSDParser
! !

!ACLibrary class methodsFor: 'ShoutCore-Parsing' stamp: 'topa 3/11/2011 18:50'!
shoutParserClass

	^ ACSHParserForLibrary
! !

!ACLibrary methodsFor: 'accessing' stamp: 'topa 3/11/2011 22:39'!
scenario
	"Answer the value of scenario"

	^ scenario! !

!ACLibrary methodsFor: 'accessing' stamp: 'topa 3/11/2011 22:39'!
scenario: anObject
	"Set the value of scenario"

	scenario := anObject! !

TestCase subclass: #ACUserStory
	instanceVariableNames: 'stepLibraries configuration currentStep stepsDone skipSymbols verbsMethodCache'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'acceptit-Core-Model'!

ACUserStory class
	instanceVariableNames: 'purpose role means userStoryString'!

ACUserStory class
	instanceVariableNames: 'purpose role means userStoryString'!

!ACUserStory class methodsFor: 'accessing' stamp: 'fg 6/30/2010 16:22'!
allTestSelectors

	^ (Pragma allNamed: #scenario in: self)
			collect: [:pragma | pragma selector]
! !

!ACUserStory class methodsFor: 'as yet unclassified' stamp: 'topa 9/26/2010 21:38'!
basicAddSelector: selector withMethod: compiledMethod 

	| methodToAdd |
	methodToAdd := self looksLikeUserStoryHeir
		ifTrue: [	ACScenarioWrapper forMethod: compiledMethod]
		ifFalse: [compiledMethod].
	super basicAddSelector: selector withMethod: methodToAdd.! !

!ACUserStory class methodsFor: 'as yet unclassified' stamp: 'topa 9/22/2010 14:37'!
buildArgumentsForMethod: aMethod using: aString

	| selector |
	selector :=  (aMethod pragmas detect: [:pragma | pragma keyword = #step:]) arguments first.
	^ (ACTranslator 
		bindParametersInSelector: selector 
		toValuesIn: aString withoutLeadingSubject withLeadingAuxiliaryNormalized)
		collect: [:assoc | assoc value]! !

!ACUserStory class methodsFor: 'configuration' stamp: 'topa 7/14/2010 12:47'!
buildConfiguration: aDictionary

	"to be used in UserStories to override Libraries defaults"! !

!ACUserStory class methodsFor: 'accessing method dictionary' stamp: 'topa 9/24/2010 09:45'!
compiledMethodAt: selector 
	"Overriden to include Scenarios"

	^ self scenarioAndMethodDict at: selector! !

!ACUserStory class methodsFor: 'accessing method dictionary' stamp: 'topa 9/22/2010 13:57'!
compiledMethodAt: selector ifAbsent: aBlock

	| key |
	key := selector asSymbol.
	^ self scenarioAndMethodDict
		at: key
		ifAbsent: [super compiledMethodAt: key ifAbsent: aBlock]! !

!ACUserStory class methodsFor: 'compiling' stamp: 'topa 6/14/2010 12:41'!
compilerClass
		
	^ self looksLikeUserStoryHeir
		ifTrue: [	ACCompiler]
		ifFalse: [super compilerClass]
! !

!ACUserStory class methodsFor: 'as yet unclassified' stamp: 'topa 3/11/2011 13:41'!
createNewVerbsMethodCache 

	^ IdentityDictionary new
		at: #given put: Dictionary new;
		at: #when put: Dictionary new;
		at: #then put: Dictionary new;
		yourself! !

!ACUserStory class methodsFor: 'fileIn/Out' stamp: 'topa 6/29/2010 15:13'!
definition

	^ self == ACUserStory
		ifTrue: [super definition]
		ifFalse: [String streamContents: [:stream |
			stream
				nextPutAll: self userStoryString printString;  crtab;
				nextPutAll: 'as: ';
				nextPutAll: (super definition findTokens: ' ') first]]
				
"				nextPutAll: (super definition findTokens: ' ') first; space;
				nextPutAll: 'named: '; nextPutAll: self name printString; crtab;
				nextPutAll: 'purpose: '; nextPutAll: self purpose printString; crtab;
				nextPutAll: 'role: '; nextPutAll: self role printString; crtab;
				nextPutAll: 'means: '; nextPutAll: self means printString"! !

!ACUserStory class methodsFor: 'testing method dictionary' stamp: 'topa 9/23/2010 14:48'!
includesSelector: aSymbol

	^ self scenarioAndMethodDict includesKey: aSymbol! !

!ACUserStory class methodsFor: 'testing' stamp: 'topa 6/3/2010 13:23'!
isAbstract

	^ self == ACUserStory! !

!ACUserStory class methodsFor: 'as yet unclassified' stamp: 'topa 7/1/2010 14:20'!
libraries

	^ #()! !

!ACUserStory class methodsFor: 'as yet unclassified' stamp: 'topa 6/14/2010 12:46'!
looksLikeUserStoryHeir
	"During recompilation of the ACUserStory class, all of
	#==, #inheritsFrom:, or #isKindOf: will fail, so we have to rely
	on the name of the class and walk the superclasses ourselves"
	
	self allSuperclassesDo: [:cls |
		cls name = #ACUserStory
			ifTrue: [^ true]].
	^ false! !

!ACUserStory class methodsFor: 'accessing' stamp: 'topa 6/3/2010 12:42'!
means

	^means! !

!ACUserStory class methodsFor: 'accessing' stamp: 'topa 6/3/2010 12:42'!
means: anObject

	means := anObject! !

!ACUserStory class methodsFor: 'as yet unclassified' stamp: 'topa 6/3/2010 12:48'!
named: aNameSymbol
purpose: purposeString
role: roleString
means: meansString

	|klass|		
	klass := self subclass: aNameSymbol
		instanceVariableNames: ''
		classVariableNames: ''
		poolDictionaries: ''
		category: self category.
	klass purpose: purposeString; role: roleString; means: meansString.
	
	^ klass! !

!ACUserStory class methodsFor: 'instance creation' stamp: 'topa 6/8/2010 14:03'!
newFrom: anObject

	(anObject isKindOf: String)
		ifTrue: [^ self userStoryFromString: anObject].

	^ super newFrom: anObject! !

!ACUserStory class methodsFor: 'organization' stamp: 'topa 9/24/2010 13:39'!
organization
	
	true 
	ifFalse: [^super organization]
	ifTrue: [
	organization ifNil: [|list|
		self organization: (ACUserStoryOrganizer defaultList:  self scenarioAndMethodDict keys sort)].

	"Making sure that subject is set correctly. It should not be necessary."
	organization setSubject: self.
	^ organization].! !

!ACUserStory class methodsFor: 'compiling' stamp: 'topa 9/22/2010 11:44'!
parserClass

	self name = #ACUserStory
		ifFalse: [
			" this is only necessary to avoid a (inapplicable) warning from the Browser"
			 "((thisContext client isKindOf: Browser) and: [
				(thisContext sender selector = #validateMessageSource:forSelector:) or:  [
				thisContext sender selector =	#validateMessageSource:forSelector:inClass: ]])
					ifTrue: [^ACUSParser]"
			^ ACUSParser].
	^ super parserClass
! !

!ACUserStory class methodsFor: 'accessing' stamp: 'topa 6/3/2010 12:42'!
purpose

	^purpose! !

!ACUserStory class methodsFor: 'accessing' stamp: 'topa 6/3/2010 12:42'!
purpose: anObject

	purpose := anObject! !

!ACUserStory class methodsFor: 'accessing' stamp: 'topa 6/3/2010 12:42'!
role

	^role! !

!ACUserStory class methodsFor: 'accessing' stamp: 'topa 6/3/2010 12:42'!
role: anObject

	role := anObject! !

!ACUserStory class methodsFor: 'as yet unclassified' stamp: 'topa 9/26/2010 21:28'!
scenarioAndMethodDict

	"1 halt."
	^ self methodDict inject: MethodDictionary new into: [:md :cMeth | 
		((cMeth respondsTo: #pragmaAt:) 
			ifFalse: [nil] "protect from unnormal cirumstances"
			ifTrue: [cMeth pragmaAt: #scenario])
				ifNil: ["normal method" md at: cMeth selector put: cMeth; yourself]
				ifNotNil: [md at: cMeth getSource asString lines first asSymbol put: cMeth; yourself]].! !

!ACUserStory class methodsFor: 'accessing' stamp: 'topa 8/5/2010 11:54'!
selectorForString: aString prefixed: aSymbol

	^ (aSymbol, 
		aString 
			withoutLeadingSubject 
			withLeadingAuxiliaryNormalized 
			asCamelCase)  asLegalSelector asSymbol! !

!ACUserStory class methodsFor: 'as yet unclassified' stamp: 'topa 7/14/2010 15:58'!
setUpUserStory

	"nothing. to be used for UserStory specific set up"! !

!ACUserStory class methodsFor: 'as yet unclassified' stamp: 'mp 4/4/2011 15:36:03.297'!
shouldInheritSelectors

	^ false! !

!ACUserStory class methodsFor: 'ShoutCore-Parsing' stamp: 'topa 9/22/2010 11:35'!
shoutParserClass

	^ (self inheritsFrom: ACUserStory)
		ifTrue: [ACUSParser]
		ifFalse: [super shoutParserClass]! !

!ACUserStory class methodsFor: 'accessing method dictionary' stamp: 'topa 9/22/2010 14:02'!
sourceCodeAt: selector ifAbsent: aBlock

	| cMeth |
	cMeth := self scenarioAndMethodDict at: selector asSymbol ifAbsent: [^ aBlock value].
	^ cMeth getSourceFor: cMeth selector in: self! !

!ACUserStory class methodsFor: 'compiling' stamp: 'topa 7/15/2010 10:37'!
sourceCodeTemplate
	
	^ self looksLikeUserStoryHeir 
		ifTrue: [
'Name of scenario

Given some preconditions
And another preconditition
When a certain event is triggered
And another "action" is invoked
Then a criterion holds
And a second criterion should be valid']
		ifFalse: [super sourceCodeTemplate]
! !

!ACUserStory class methodsFor: 'as yet unclassified' stamp: 'topa 7/14/2010 15:58'!
tearDownUserStory

	"nothing. to be used for UserStory specific tear down"! !

!ACUserStory class methodsFor: 'as yet unclassified' stamp: 'mp 3/29/2011 15:34:39.94'!
userStoryFromString: anObject

	| newClass |
	newClass := (Compiler 
		evaluate: (ACTranslator 
			match: (ACUSParser matchAll: anObject readStream with: #userStory withArgs: #()) 
			with: #scenario)
		notifying: nil 
		logged: true).
	newClass class compile:
	('initialize
	
	super initialize.
	self userStoryString: ', anObject printString, '. ')
	classified: 'initialize-release'.
	^ newClass initialize! !

!ACUserStory class methodsFor: 'as yet unclassified' stamp: 'topa 6/29/2010 15:12'!
userStoryString

	^ userStoryString! !

!ACUserStory class methodsFor: 'as yet unclassified' stamp: 'topa 6/29/2010 15:11'!
userStoryString: aString

	userStoryString := aString.! !

!ACUserStory methodsFor: 'running' stamp: 'topa 7/15/2010 09:30'!
configuration

	^ configuration ifNil: [
		self configuration: IdentityDictionary new.
		self stepLibraries do: [:library |
			(library respondsTo: #buildDefaultConfiguration:) ifTrue: [
				library buildDefaultConfiguration: configuration]].
		self class buildConfiguration: configuration.
		configuration].
	! !

!ACUserStory methodsFor: 'accessing' stamp: 'topa 2/14/2011 09:33'!
configuration: anObject
	"Set the value of configuration"

	configuration := anObject.! !

!ACUserStory methodsFor: 'accessing' stamp: 'topa 2/14/2011 09:32'!
currentStep
	"Answer the value of currentStep"

	^ currentStep! !

!ACUserStory methodsFor: 'accessing' stamp: 'topa 3/11/2011 15:25'!
currentStep: anObject
	"Set the value of currentStep"

	self stepsDone add: anObject.
	currentStep := anObject.! !

!ACUserStory methodsFor: 'as yet unclassified' stamp: 'topa 8/31/2010 04:04'!
defaultTimeout

	"disable"
	^ 600! !

!ACUserStory methodsFor: 'error handling' stamp: 'db 7/21/2010 14:57'!
doesNotUnderstand: aMessage

	^ aMessage sendTo: (self findLibraryForSelector: aMessage selector ifNone:[^ super doesNotUnderstand: aMessage]).
	! !

!ACUserStory methodsFor: 'error handling' stamp: 'db 7/21/2010 15:01'!
findLibraryForSelector: aSelector ifNone: aBlock

	^ self stepLibraries detect: [:lib | lib respondsTo: aSelector]
		ifNone: [aBlock value].
	! !

!ACUserStory methodsFor: 'internal verbs' stamp: 'topa 9/24/2010 17:21'!
given: aString

	^ self invokeVerb: #given for: aString
! !

!ACUserStory methodsFor: 'as yet unclassified' stamp: 'topa 10/13/2010 16:46'!
givenScenario: aSymbol

	self withoutThenDo: [self perform: aSymbol]! !

!ACUserStory methodsFor: 'initialize-release' stamp: 'db 10/24/2010 22:44'!
initialize

	super initialize.
	self stepLibraries: OrderedCollection new.
	
	" initialize the delegate libraries"
	self class libraries do: [:library |
		self stepLibraries add: (library newForScenario: self)].

	! !

!ACUserStory methodsFor: 'internal verbs' stamp: 'topa 2/14/2011 09:19'!
invokeVerb: verbSymbol for: aString

	| method args|
	method := self methodForVerb: verbSymbol andStep: aString.
	
	(self shouldInvoke: method forVerb: verbSymbol andStep: aString)
		ifTrue: [
			args := self class buildArgumentsForMethod: method using: aString.
			^ method valueWithReceiver: self arguments: {args}]
! !

!ACUserStory methodsFor: 'running' stamp: 'topa 8/31/2010 04:13'!
mapFromString: aString toStepMethodWithVerb: aSymbol
	
	(self methodsForVerb: aSymbol) do: [:method |
		method pragmas do: [:pragma | 
			((pragma keyword = #stepMatch:) and: 
				[(pragma arguments first) match: aString withoutLeadingSubject withLeadingAuxiliaryNormalized])
				ifTrue: [^ method]]].
	^ self notYetImplemented! !

!ACUserStory methodsFor: 'internal verbs' stamp: 'mp 3/29/2011 16:17:43.654'!
methodForVerb: aSymbol andStep: aString

	^ [(self verbsMethodCache at: aSymbol)
		at: aString 
		ifAbsentPut: (self mapFromString: aString toStepMethodWithVerb: aSymbol)
	] on: NotYetImplemented do: [:nyi | |resignal|
		resignal := NotYetImplemented new.
		resignal receiverClass: self class selector: nil.
		resignal messageText: aSymbol printString, ' for ', aString.
		nyi resignalAs: resignal.		
	]! !

!ACUserStory methodsFor: 'running' stamp: 'topa 3/11/2011 13:35'!
methodsForVerb: aSymbol

	^ Array streamContents: [:stream |
		self stepLibraries do: [:lib |
			(Pragma allNamed: #stepTag: in: lib class) do: [:pragma |
				(pragma arguments first = aSymbol) 
					ifTrue: [stream nextPut: pragma method]]]]! !

!ACUserStory methodsFor: 'internal verbs' stamp: 'topa 3/11/2011 15:14'!
registerCurrentInvokationOf: method forVerb: verbSymbol andStep: aString.

	self currentStep: verbSymbol -> aString -> method.! !

!ACUserStory methodsFor: 'private' stamp: 'db 10/25/2010 00:28'!
run
	| result |
	result := ACScenarioResult new.
	self run: result.
	^result
			! !

!ACUserStory methodsFor: 'running' stamp: 'topa 2/14/2011 09:15'!
runCase
	
	<timeout: 10>
	[super runCase]
	on: NotYetImplemented
	do: [self signalFailure: 'Step not yet implemented']! !

!ACUserStory methodsFor: 'running' stamp: 'topa 7/14/2010 15:57'!
setUp

	super setUp.
	self class setUpUserStory.
	(self stepLibraries)
		do: [:library | (library respondsTo: #setUp) ifTrue: [library setUp]];
		do: [:library | (library respondsTo: #setUpUserStory:) ifTrue: [library setUpUserStory: self class name]];
		do: [:library | (library respondsTo: #setUpScenario:) ifTrue: [library setUpScenario: self selector]]		! !

!ACUserStory methodsFor: 'internal verbs' stamp: 'topa 2/14/2011 09:24'!
shouldInvoke: method forVerb: verbSymbol andStep: aString

	self registerCurrentInvokationOf: method forVerb: verbSymbol andStep: aString.
	
	^ (self skipSymbols includes: verbSymbol) not! !

!ACUserStory methodsFor: 'as yet unclassified' stamp: 'topa 10/13/2010 16:52'!
skipSymbols
		
	^ skipSymbols ifNil: [skipSymbols := IdentitySet new]! !

!ACUserStory methodsFor: 'as yet unclassified' stamp: 'topa 10/13/2010 16:52'!
skipSymbols: anIdentitySet
		
	skipSymbols := anIdentitySet ! !

!ACUserStory methodsFor: 'private' stamp: 'topa 7/14/2010 15:20'!
stepLibraries

	^stepLibraries! !

!ACUserStory methodsFor: 'private' stamp: 'topa 7/14/2010 15:20'!
stepLibraries: anObject

	stepLibraries := anObject! !

!ACUserStory methodsFor: 'accessing' stamp: 'topa 3/11/2011 15:26'!
stepsDone 

	^ stepsDone ifNil: [stepsDone := OrderedCollection new]! !

!ACUserStory methodsFor: 'running' stamp: 'topa 7/14/2010 15:57'!
tearDown


	(self stepLibraries)
		do: [:library | (library respondsTo: #tearDownScenario:) ifTrue: [library tearDownScenario: self selector]];
		do: [:library | (library respondsTo: #tearDownUserStory:) ifTrue: [library tearDownUserStory: self class name]];
		do: [:library | (library respondsTo: #tearDown) ifTrue: [library tearDown]].
	self class tearDownUserStory.
	super tearDown.! !

!ACUserStory methodsFor: 'accessing' stamp: 'topa 3/11/2011 14:38'!
testMethod

	^ self class >> self selector! !

!ACUserStory methodsFor: 'accessing' stamp: 'topa 3/11/2011 14:38'!
testMethodSource

	^ self class sourceCodeAt: self selector! !

!ACUserStory methodsFor: 'internal verbs' stamp: 'topa 10/13/2010 16:20'!
then: aString

	self invokeVerb: #then for: aString
	! !

!ACUserStory methodsFor: 'accessing' stamp: 'topa 3/11/2011 13:44'!
verbsMethodCache
	"Answer the value of verbsMethodCache"

	^ verbsMethodCache ifNil: [
		verbsMethodCache := self class createNewVerbsMethodCache]
! !

!ACUserStory methodsFor: 'internal verbs' stamp: 'topa 9/24/2010 17:21'!
when: aString

	^ self invokeVerb: #when for: aString
! !

!ACUserStory methodsFor: 'as yet unclassified' stamp: 'topa 10/13/2010 16:51'!
withoutThenDo: aBlock

	^ (self skipSymbols includes: #then)
		ifFalse: [
			self skipSymbols add: #then.
			aBlock ensure: [self skipSymbols remove: #then]]
		ifTrue: [aBlock value]! !

ProtoObject subclass: #ACScenarioWrapper
	instanceVariableNames: 'method'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'acceptit-Core-Compiler'!

!ACScenarioWrapper class methodsFor: 'as yet unclassified' stamp: 'topa 9/26/2010 21:30'!
forMethod: compiledMethod

	^ self basicNew initializeWithMethod: compiledMethod
	"NO yourself in here, ProtoObject does not know about it and we would
	end up with the compiledMethod"! !

!ACScenarioWrapper methodsFor: 'system primitives' stamp: 'topa 9/26/2010 21:30'!
doesNotUnderstand: aMessage

	^ method perform: aMessage selector withArguments: aMessage arguments! !

!ACScenarioWrapper methodsFor: 'initialize-release' stamp: 'topa 9/26/2010 21:31'!
initializeWithMethod: aCompiledMethod

	method := aCompiledMethod.
! !

!ACScenarioWrapper methodsFor: 'proxied protocol' stamp: 'topa 3/11/2011 14:19'!
messages

	| messages pt targetSubject|
	messages := method messages.
	targetSubject := method methodClass selector: method selector. "should be an ACUserStory"
	pt := self parserClass matchStream: (method getSource asString readStream) with: #scenario withArgs: #() withPlaybackDebugging: false.

	pt allButFirst "withoutTag, i.e. scenario"
		do: [:subTree |
			(#(given when then) includes: subTree first) ifTrue: ["valid verb"
				|verb |
				verb := subTree first.
				subTree allButFirst do: [:actionString | "all strings for that tag"
					[(targetSubject methodForVerb: verb andStep: actionString) selector
						ifNotNil: [:selector |
							messages add: selector]
					] on: NotYetImplemented do: [:error | "fallthrough" ]]]].
	^ messages
! !

!ACScenarioWrapper methodsFor: 'evaluation' stamp: 'topa 9/26/2010 21:32'!
run: aSelector with: anArray in: aReceiver

	^ aReceiver withArgs: anArray executeMethod: method
! !

!ACScenarioWrapper methodsFor: 'debugging' stamp: 'topa 9/26/2010 21:31'!
theCompiledMethod

	^ method! !

SHParserST80 subclass: #ACSHParserForLibrary
	instanceVariableNames: 'inScanLine'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'acceptit-Core-Compiler'!

!ACSHParserForLibrary methodsFor: 'eol-helper' stamp: 'topa 9/22/2010 07:38'!
atEndOfLine


	^ self isEndOfLine: currentTokenFirst! !

!ACSHParserForLibrary methodsFor: 'accessing' stamp: 'topa 8/31/2010 09:37'!
inScanLine
	
	^ inScanLine! !

!ACSHParserForLibrary methodsFor: 'accessing' stamp: 'topa 8/31/2010 09:14'!
inScanLine: aBoolean
	
	inScanLine := aBoolean! !

!ACSHParserForLibrary methodsFor: 'accessing' stamp: 'topa 9/22/2010 12:24'!
initialize

	super initialize.
	self inScanLine: false.! !

!ACSHParserForLibrary methodsFor: 'eol-helper' stamp: 'topa 8/31/2010 09:48'!
isEndOfLine: c

	^ ((c == Character cr)
	or: [c == Character lf])
	or: [c charCode = 12]
! !

!ACSHParserForLibrary methodsFor: 'parse' stamp: 'topa 8/31/2010 08:52'!
parseMessagePattern

	(currentTokenFirst == $( )
		ifTrue: [self scanLine]
		ifFalse: [super parseMessagePattern]! !

!ACSHParserForLibrary methodsFor: 'scan' stamp: 'topa 9/22/2010 07:39'!
scanLine

	self inScanLine: true.
	"(given)"
	bracketDepth := bracketDepth + 1.
	self scanPast: #leftParenthesis level: bracketDepth.
	self parseUnaryMessagePattern.
	self failUnless: currentTokenFirst == $).
	self scanPast: #rightParenthesis level: bracketDepth.
	bracketDepth := bracketDepth - 1.
	
	[self atEndOfLine] whileFalse: [
		self parseUnaryMessagePattern.
		(currentTokenFirst == $:)
			ifTrue: [
				self scanPast: #blockArgColon.
				self failUnless: self isName.
				self scanPast: #blockPatternArg].
	].
	self inScanLine: false.
	self scanNext.! !

!ACSHParserForLibrary methodsFor: 'scan' stamp: 'topa 8/31/2010 09:50'!
scanWhitespace

	| c |
	self inScanLine ifFalse: [^ super scanWhitespace].
	
	[c := self currentChar.
	(c notNil and: [c isSeparator]) and: [(self isEndOfLine: c) not]] 
		whileTrue: [sourcePosition := sourcePosition + 1].
	c == $" ifTrue: [self scanComment]! !
